- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# sbuild::chroot_file Class Reference

A chroot stored in a file archive (tar or zip). More...

`#include <sbuild-chroot-file.h>`

Inheritance diagram for sbuild::chroot_file:

[legend]
Collaboration diagram for sbuild::chroot_file:

[legend]
List of all members.

## Public Member Functions
virtual | ~chroot_file ()
| The destructor.
virtual chroot::ptr | clone () const
| Copy the chroot.
virtual chroot::ptr | clone_source () const
| Create a source chroot.
std::string const & | get_file () const
| Get the file used by the chroot.
void | set_file (std::string const &file)
| Set the file used by the chroot.
bool | get_file_repack () const
| Get the repack status.
void | set_file_repack (bool repack)
| Set the file repack status.
virtual std::string const & | get_chroot_type () const
| Get the type of the chroot.
virtual void | setup_env (environment &env)
| Set environment.
virtual session_flags | get_session_flags () const
| Get the session flags of the chroot.
## Protected Member Functions
| chroot_file ()
| The constructor.
virtual void | setup_lock (chroot::setup_type type, bool lock, int status)
| Unlock a chroot during setup.
virtual void | get_details (format_detail &detail) const
| Get detailed information about the chroot for output.
virtual void | get_keyfile (keyfile &keyfile) const
| Copy the chroot properties into a keyfile.
virtual void | set_keyfile (keyfile const &keyfile)
| Set the chroot properties from a keyfile.
## Private Attributes
std::string | file
| The file to use.
bool | repack
| Should the chroot be repacked?
## Friends
class | chroot

## Detailed Description

A chroot stored in a file archive (tar or zip).

The archive will be unpacked on demand.

## Constructor & Destructor Documentation

chroot_file::chroot_file | ( |  | ) | `[protected]`

The constructor.

chroot_file::~chroot_file | ( |  | ) | `[virtual]`

The destructor.

## Member Function Documentation

sbuild::chroot::ptr chroot_file::clone | ( |  | ) | const`[virtual]`

Copy the chroot.

This is a virtual copy constructor.

Returns:
  a shared_ptr to the new copy of the chroot.

Implements sbuild::chroot.

sbuild::chroot::ptr chroot_file::clone_source | ( |  | ) | const`[virtual]`

Create a source chroot.

Returns:
  a source chroot.

Implements sbuild::chroot_source.

std::string const & chroot_file::get_chroot_type | ( |  | ) | const`[virtual]`

Get the type of the chroot.

Returns:
  the chroot type.

Implements sbuild::chroot.

void chroot_file::get_details | ( | format_detail & | detail | ) | const`[protected, virtual]`

Get detailed information about the chroot for output.

Parameters:

  | detail | the details to output to.

Reimplemented from sbuild::chroot_source.

std::string const & chroot_file::get_file | ( |  | ) | const

Get the file used by the chroot.

Returns:
  the file.

bool chroot_file::get_file_repack | ( |  | ) | const

Get the repack status.

This is true if the unpacked archive file will be repacked.

Returns:
  the repack status.

void chroot_file::get_keyfile | ( | keyfile & | keyfile | ) | const`[protected, virtual]`

Copy the chroot properties into a keyfile.

The keyfile group with the name of the chroot will be set; if it already exists, it will be removed before setting it.

Parameters:

  | keyfile | the keyfile to use.

Reimplemented from sbuild::chroot_source.

sbuild::chroot::session_flags chroot_file::get_session_flags | ( |  | ) | const`[virtual]`

Get the session flags of the chroot.

These determine how the Session controlling the chroot will operate.

Returns:
  the session flags.

Implements sbuild::chroot.

void chroot_file::set_file | ( | std::string const & | file | ) |

Set the file used by the chroot.

Parameters:

  | file | the file.

void chroot_file::set_file_repack | ( | bool | repack | ) |

Set the file repack status.

Set to true if the unpacked archive file will be repacked on session cleanup, or false to discard.

Parameters:

  | repack | the repack status.

void chroot_file::set_keyfile | ( | keyfile const & | keyfile | ) | `[protected, virtual]`

Set the chroot properties from a keyfile.

The chroot name must have previously been set, so that the correct keyfile group may be determined.

Parameters:

  | keyfile | the keyfile to get the properties from.

Reimplemented from sbuild::chroot_source.

void chroot_file::setup_env | ( | environment & | env | ) | `[virtual]`

Set environment.

Set the environment that the setup scripts will see during execution.

Parameters:

  | env | the environment to set.

Reimplemented from sbuild::chroot_source.

void chroot_file::setup_lock | ( | chroot::setup_type | type,
|  | bool | lock,
|  | int | status |
| ) |  |  | `[protected, virtual]`

Unlock a chroot during setup.

The locking technique (if any) may vary depending upon the chroot type and setup stage. For example, during creation of an LVM snapshot a block device might require locking, but afterwards this will change to the new block device.

An error will be thrown on failure.

Parameters:

  | type | the type of setup being performed
  | lock | true to lock, false to unlock
  | status | the exit status of the setup commands (0 for success, nonzero for failure).

Implements sbuild::chroot.

## Friends And Related Function Documentation

friend class chroot`[friend]`

Reimplemented from sbuild::chroot_source.

## Member Data Documentation

std::string sbuild::chroot_file::file`[private]`

The file to use.

bool sbuild::chroot_file::repack`[private]`

Should the chroot be repacked?

The documentation for this class was generated from the following files:

- sbuild/sbuild-chroot-file.h
- sbuild/sbuild-chroot-file.cc